#  AreaEd - an editor for rom-style areas, especially for
#  Dawn of the Ages  http://dawn.netcologne.de
#
#  Copyright (C) 2001 Peter Herth <p.herth@uni-koeln.de>
#
# This program is free software; you can redistribute it and/or
# modify it under the terms of the GNU General Public License
# as published by the Free Software Foundation; either version 2
# of the License, or (at your option) any later version.
# 
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
# 
# You should have received a copy of the GNU General Public License
# along with this program; if not, write to the Free Software
# Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.



from gtk import *
from gnome.ui import *
from GtkExtra import *
from GDK import *
from GTK import *

from Tools import *
#from Area import *
import Area


class ItemForm(EditForm):
    
##    actitem = 0
##    item = None

##    def nextItem(self, *arg):
##        if self.actitem < (len(self.ed.area.items)-1):
##            self.actitem = self.actitem + 1
##            self.setItem(self.ed.area.items[self.actitem])
                
##    def prevItem(self, *arg):
##        if self.actitem>0:
##            self.actitem = self.actitem -1
##            self.setItem(self.ed.area.items[self.actitem])

    def __init__(self, ed):
        EditForm.__init__(self, ed, ed.area.items)
        self.ed = ed
        self.extraflags = []
        self.wearflags = []
        self.tooltips = GtkTooltips()

        ##table = GtkTable(5,11,FALSE);
        self.vnum = mk_le("Vnum:",self,0,1)

##        prev = mk_gbu(STOCK_BUTTON_PREV,self,5,0,7)
##        next = mk_gbu(STOCK_BUTTON_NEXT,self,7,0,9)
##        prev.connect("clicked",self.prevItem)
##        next.connect("clicked",self.nextItem)

        self.name = mk_le("Name:",self,0,2,8)
        self.short = mk_le("Short:", self, 0, 3, 8)
        self.long = mk_le("Long:", self, 0, 4, 8)

        mklabel("Look:", self, 0,5)
        look = GtkText()
        look.set_editable(TRUE)
        look.set_usize(1,ITEMDESCHEIGHT)
        look.show()
        self.attach(look,1,8,5,7,FILL|EXPAND|SHRINK,EXPAND|FILL, XPAD, YPAD)
        self.look = look

        self.material = mk_le("Material:",self, 0, 8)
        self.type =  mk_le("Type:",self, 2, 8)
        
        self.v0 = mk_le("V0-5",self, 0,9)
        self.v1 = mkentry(self, 2, 9)
        self.v2 = mkentry(self, 3, 9)
        self.v3 = mkentry(self, 4, 9)
        self.v4 = mkentry(self, 5, 9)

        self.level = mk_le("Level", self, 0, 10)
        self.weight = mk_le("Weight", self, 2, 10)
        self.cost = mk_le("Cost:", self, 4, 10)
        self.timer = mk_le("Timer:", self, 6, 10)

        note_flags = GtkNotebook()
        note_flags.set_tab_pos = POS_TOP

        f = GtkFrame("Flags")

        note_flags.append_page(createFlags("wearflag.dat",self.wearflags,self.tooltips), GtkLabel("Wear"))
        note_flags.append_page(createFlags("extraflag.dat",self.extraflags, self.tooltips), GtkLabel("Extra"))
        ff = GtkFrame()
        self.extraEd = ExtraEdit([])
        note_flags.append_page(self.extraEd, GtkLabel("Extras"))
        
        f.add(note_flags)
        self.attach(f, 1, 6,11, 13,FILL,FILL)


##        frame = GtkFrame()
##        frame.set_shadow_type(SHADOW_NONE)
##        frame.add(table)
##        self.frame = frame


    def setValues(self, item):
        item.vnum = self.vnum.get_text()
        item.name = self.name.get_text()
        item.short = self.short.get_text()
        item.look = self.look.get_chars(0,self.look.get_length())
        item.type = self.type.get_text()
        item.extraflags = getFlags(self.extraflags)
        item.wearflags = getFlags(self.wearflags)

        item.v0 = self.v0.get_text()
        item.v1 = self.v1.get_text()
        item.v2 = self.v2.get_text()
        item.v3 = self.v3.get_text()
        item.v4 = self.v4.get_text()

        item.level  = int(self.level.get_text())
        item.weight = int(self.weight.get_text())
        item.cost   = int(self.cost.get_text())
        item.timer  = self.timer.get_text()
        
        item.extras = self.extraEd.getExtraList()


    def fillValues(self, item):
        self.vnum.set_text(item.vnum)
        self.name.set_text(item.name)
        self.short.set_text(item.short)
        self.long.set_text(item.long)
        self.look.delete_text(0,-1)
        self.look.insert_defaults(item.look)
        self.material.set_text(item.material)
        
        self.type.set_text(item.type)
        setFlags(item.extraflags, self.extraflags)
        setFlags(item.wearflags, self.wearflags)

        self.v0.set_text(item.v0)
        self.v1.set_text(item.v1)
        self.v2.set_text(item.v2)
        self.v3.set_text(item.v3)
        self.v4.set_text(item.v4)

        self.level.set_text("%d" % item.level)
        self.weight.set_text("%d" % item.weight)
        self.cost.set_text("%d" % item.cost)
        self.timer.set_text(item.timer)
        self.extraEd.setExtraList(item.extras)


    def empty(self):
        self.vnum.set_text("")
        self.name.set_text("")
        self.short.set_text("")
        self.long.set_text("")
        self.look.delete_text(0,-1)
        self.material.set_text("")
        
        self.type.set_text("")
        setFlags("", self.extraflags)
        setFlags("", self.wearflags)

        self.v0.set_text("")
        self.v1.set_text("")
        self.v2.set_text("")
        self.v3.set_text("")
        self.v4.set_text("")

        self.level.set_text("0")
        self.weight.set_text("0")
        self.cost.set_text("0")
        self.timer.set_text("0")
        self.extraEd.setExtraList([])


    def create_new(self):
        if len(self.list)>0:
            return Area.Item(Area.vnum_inc(self.list[len(self.list)-1].vnum))
        else:
            return Area.Item()



##    def saveItem(self):
##        if self.item ==None:
##            return

##        item = self.item
        
##        item.vnum = self.vnum.get_text()
##        item.name = self.name.get_text()
##        item.short = self.short.get_text()
##        item.look = self.look.get_chars(0,self.look.get_length())
##        item.type = self.type.get_text()
##        item.extraflags = getFlags(self.extraflags)
##        item.wearflags = getFlags(self.wearflags)

##        item.v0 = self.v0.get_text()
##        item.v1 = self.v1.get_text()
##        item.v2 = self.v2.get_text()
##        item.v3 = self.v3.get_text()
##        item.v4 = self.v4.get_text()

##        item.level  = int(self.level.get_text())
##        item.weight = int(self.weight.get_text())
##        item.cost   = int(self.cost.get_text())
##        item.timer  = self.timer.get_text()
        
##        item.extras = self.extraEd.getExtraList()

##    def setItem(self, item):
##        self.saveItem()
##        self.item = item
##        self.vnum.set_text(item.vnum)
##        self.name.set_text(item.name)
##        self.short.set_text(item.short)
##        self.long.set_text(item.long)
##        self.look.delete_text(0,-1)
##        self.look.insert_defaults(item.look)
##        self.material.set_text(item.material)
        
##        self.type.set_text(item.type)
##        setFlags(item.extraflags, self.extraflags)
##        setFlags(item.wearflags, self.wearflags)

##        self.v0.set_text(item.v0)
##        self.v1.set_text(item.v1)
##        self.v2.set_text(item.v2)
##        self.v3.set_text(item.v3)
##        self.v4.set_text(item.v4)

##        self.level.set_text("%d" % item.level)
##        self.weight.set_text("%d" % item.weight)
##        self.cost.set_text("%d" % item.cost)
##        self.timer.set_text(item.timer)
##        self.extraEd.setExtraList(item.extras)

    def setVi(self, ac):
        self.v0.set_text("%d" % ac)
        self.v1.set_text("%d" % ac)
        self.v2.set_text("%d" % ac)
        self.v3.set_text("%d" % ac)


    def calcAcNorm(self, *args):
        if self.item == None:
            return
        self.saveItem()
        ac = calcAc(self.item, -1)
        self.setVi(ac)

    def calcAcLeg(self, *args):
        if self.item == None:
            return
        self.saveItem()
        ac = calcAc(self.item, 0)
        self.setVi(ac)

    def calcAcLim1(self, *args):
        if self.item == None:
            return
        self.saveItem()
        ac = calcAc(self.item, 1)
        self.setVi(ac)
        
    def calcAcLim2(self, *args):
        if self.item == None:
            return
        self.saveItem()
        ac = calcAc(self.item, 2)
        self.setVi(ac)

