#  AreaEd - an editor for rom-style areas, especially for
#  Dawn of the Ages  http://dawn.netcologne.de
#
#  Copyright (C) 2001 Peter Herth <p.herth@uni-koeln.de>
#
# This program is free software; you can redistribute it and/or
# modify it under the terms of the GNU General Public License
# as published by the Free Software Foundation; either version 2
# of the License, or (at your option) any later version.
# 
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
# 
# You should have received a copy of the GNU General Public License
# along with this program; if not, write to the Free Software
# Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.

import Area

from gtk import *
from Tools import *
from math import *

def a(d,sign):
    d = d*sign
    if d<20:
        return sign * -8 #max(-8,(d-20))
    elif d==0:
        return 0
    else:
        return sign * (d-20)/40


class Optimizer(GtkWindow):
    def __init__(self,map, ed):
        GtkWindow.__init__(self, WINDOW_TOPLEVEL, "Optimizer")
        self.ed = ed
        self.map = map
        table = GtkTable(2,2)


        optimize = mk_bu("1 optimize run", table, 0, 0,-1,SHRINK|EXPAND|FILL)
        optimize.connect("clicked", self.optimize1)
        optimize = mk_bu("10 optimize runs", table, 0, 1,-1,SHRINK|EXPAND|FILL)
        optimize.connect("clicked", self.optimize10)
        optimize = mk_bu("100 optimize runs", table, 0, 2,-1, SHRINK|EXPAND|FILL)
        optimize.connect("clicked", self.optimize100)
        optimize = mk_bu("Rasterize", table, 0, 3,-1,SHRINK|EXPAND|FILL)
        optimize.connect("clicked", self.rasterize)
        box = mk_chk("repulsion force", table, 0,4)
        self.force = box
        self.add(table)

    def optimize1(self, *args):
        self.optimize(1,self.force.get_active())
    def optimize10(self, *args):
        self.optimize(10,self.force.get_active())
    def optimize100(self, *args):
        self.optimize(100,self.force.get_active())

        
    def optimize(self,niter=1,use_dist=1):
        for i in range(niter):
            print "run nr.",i
            for r in self.ed.area.rooms:
                fx = 0
                fy = 0
                for e in r.exits:
                    if e:
                        to = self.ed.area.get_room(e.roomToVnum)
                        if to and to!=r:
                            dx = to.x-r.x
                            dy = to.y-r.y
                            if e.dir == 0:
                                fy = fy + a(dy,-1)
                                fx = fx + dx*1.8 #max(-5, min(5,dx*1.8))
                            elif e.dir == 2:
                                fy = fy + a(dy,+1)
                                fx = fx + dx*1.8 #max(-5, min(5,dx * 1.8))
                            elif e.dir == 1:
                                fy = fy + dy*1.8 #max(-5, min(5,dy * 1.8))
                                fx = fx + a(dx,+1)
                            elif e.dir == 3:
                                fy = fy + dy*1.8 #max(-5, min(5,dy * 1.8))                
                                fx = fx + a(dx,-1)
                            else:
                                fy = fy + dy
                                fx = fx + dx
                if use_dist:
                    
                    for r2 in self.ed.area.rooms:
                        if r2!=r:
                            d= sqrt((r2.x-r.x)**2+(r2.y-r.y)**2)
                            if (d<20):
                                fx = fx + (r.x-r2.x)
                                fy = fy + (r.y-r2.y)
                                
                            
                r.x = r.x + max(-1, min(1, fx))
                r.y = r.y + max(-1, min(1, fy))
                r.calcCoords()
        for r in self.ed.area.rooms:
            r.rect.set(x1=r.x1, y1=r.y1, x2=r.x2, y2=r.y2)
            for e in r.exits:
                if e:
                    e.render(r, self.map.canvas, self.ed.area)

        self.map.canvas.update_now()

    def rasterize(self, *args):
       for r in self.ed.area.rooms:
           r.x = 20*int(round(r.x/20))
           r.y = 20*int(round(r.y/20))
           r.calcCoords()
           r.rect.set(x1=r.x1, y1=r.y1, x2=r.x2, y2=r.y2)
       for r in self.ed.area.rooms:
           for e in r.exits:
               if e:
                   e.render(r, self.map.canvas, self.ed.area)




       self.map.canvas.update_now()



##    def rasterize(self):
##        self.x = 20*int(round(self.x/20))
##        self.y = 20*int(round(self.y/20))
##        self.calcCoords()
##        self.rect.set(x1=self.x1, y1=self.y1, x2=self.x2, y2=self.y2)
##        for e in self.exits:
##            if e:
##                e.render(self, self.canvas, self.area)

    
